package com.diagbot.facade;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.diagbot.entity.ModuleDetail;
import com.diagbot.entity.ModuleInfo;
import com.diagbot.enums.IsDeleteEnum;
import com.diagbot.service.ModuleDetailService;
import com.diagbot.service.impl.ModuleDetailServiceImpl;
import com.diagbot.util.DateUtil;
import com.diagbot.vo.AddModuleInfoVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @Author:zhoutg
 * @time: 2018/11/23 11:37
 */
@Component
public class ModuleDetailFacade extends ModuleDetailServiceImpl {

    @Autowired
    private ModuleInfoFacade moduleInfoFacade;
    @Autowired
    @Qualifier("moduleDetailServiceImpl")
    private ModuleDetailService moduleDetailService;
    /**
     * 根据questionId删除明细
     *
     * @param map
     * @return
     */
    public void deleteByQuestionIdFac(Map map) {
        this.deleteByQuestionIds(map);
    }


    /**
     * 根据moduleId删除明细
     *
     * @param map
     * @return
     */
    public void deleteByModuleIdFac(Map map) {
        this.deleteByModuleIds(map);
    }

    /**
     * 添加模板明细
     *
     * @param addModuleInfoVO
     * @return
     */
    public Boolean saveOrUpdateInfos(AddModuleInfoVO addModuleInfoVO){
        /*String userId = UserUtils.getCurrentPrincipleID();*/
        Date now = DateUtil.now();
        //获取添加的模板信息
        QueryWrapper<ModuleInfo> moduleInfoQueryWrapper = new QueryWrapper<>();
        moduleInfoQueryWrapper.eq("is_deleted", IsDeleteEnum.N.getKey())
            .eq("name",addModuleInfoVO.getName())
            .eq("type",addModuleInfoVO.getType());
        ModuleInfo moduleInfo = moduleInfoFacade.getOne(moduleInfoQueryWrapper);
        //如果该模板添加过明细，先删除
        UpdateWrapper<ModuleDetail> moduleDetailUpdateWrapper = new UpdateWrapper<>();
        moduleDetailUpdateWrapper.eq("is_deleted", IsDeleteEnum.N.getKey())
                .eq("module_id",moduleInfo.getId())
                .set("is_deleted",IsDeleteEnum.Y.getKey())
                .set("modifier","1"/*userId*/)
                .set("gmt_modified",now);
        this.update(new ModuleDetail(),moduleDetailUpdateWrapper);
        //重新添加明细
        List<ModuleDetail> moduleDetailList = new ArrayList<>();
        ModuleDetail moduleDetail = null;
        for(int i = 0; i < addModuleInfoVO.getModelDetils().size(); i++){
            moduleDetail = new ModuleDetail();
            moduleDetail.setModuleId(moduleInfo.getId());
            moduleDetail.setCreator("1"/*userId*/);
            moduleDetail.setModifier("1"/*userId*/);
            moduleDetail.setGmtCreate(now);
            moduleDetail.setGmtModified(now);
            moduleDetail.setQuestionId(addModuleInfoVO.getModelDetils().get(i).getQuestionId());
            moduleDetail.setModuleId(moduleInfo.getId());
            moduleDetail.setOrderNo(i+1);
            moduleDetailList.add(moduleDetail);
        }
        moduleDetailService.saveBatch(moduleDetailList);
        return true;
    }
}
